diff --git a/src/uefi/uefirtauthvar/authvardefs.h b/src/uefi/uefirtauthvar/authvardefs.h
index 156ece4..ec66614 100644
--- a/src/uefi/uefirtauthvar/authvardefs.h
+++ b/src/uefi/uefirtauthvar/authvardefs.h
@@ -266,4 +266,127 @@ static uint8_t AuthVarDel[] = {
 	0x65, 0xb6, 0xff, 0xbf, 0xbd, 0x08, 0xe1, 0xed, 0x0c, 0x19, 0xb2
 };
 
+/*
+ * AuthVarCreateDiffer, the same as AuthVarCreate, but using different valid key and new timestamp
+ * timestamp: 2014.09.08:05:52:01
+ * GUID: 7f5c5d52-2f14-4f12-967cdb60db05a0fd
+ * attributes = UEFI_VAR_NON_VOLATILE, UEFI_VAR_BOOTSERVICE_ACCESS,
+ *		UEFI_VAR_RUNTIME_ACCESS, UEFI_VARIABLE_TIME_BASED_AUTHENTICATED_WRITE_ACCESS
+ * Variable name: AuthVarTest
+ * data content: 1234567890abcdef
+ */
+static uint8_t AuthVarCreateDiff[] = {
+	0xde, 0x07, 0x09, 0x08, 0x05, 0x34, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x0b, 0x05, 0x00, 0x00, 0x00, 0x02, 0xf1, 0x0e,
+	0x9d, 0xd2, 0xaf, 0x4a, 0xdf, 0x68, 0xee, 0x49, 0x8a, 0xa9, 0x34, 0x7d,
+	0x37, 0x56, 0x65, 0xa7, 0x30, 0x82, 0x04, 0xef, 0x06, 0x09, 0x2a, 0x86,
+	0x48, 0x86, 0xf7, 0x0d, 0x01, 0x07, 0x02, 0xa0, 0x82, 0x04, 0xe0, 0x30,
+	0x82, 0x04, 0xdc, 0x02, 0x01, 0x01, 0x31, 0x0f, 0x30, 0x0d, 0x06, 0x09,
+	0x60, 0x86, 0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x01, 0x05, 0x00, 0x30,
+	0x0b, 0x06, 0x09, 0x2a, 0x86, 0x48, 0x86, 0xf7, 0x0d, 0x01, 0x07, 0x01,
+	0xa0, 0x82, 0x02, 0xfd, 0x30, 0x82, 0x02, 0xf9, 0x30, 0x82, 0x01, 0xe1,
+	0xa0, 0x03, 0x02, 0x01, 0x02, 0x02, 0x09, 0x00, 0xe2, 0x7d, 0x10, 0xea,
+	0xd8, 0x0d, 0x98, 0x77, 0x30, 0x0d, 0x06, 0x09, 0x2a, 0x86, 0x48, 0x86,
+	0xf7, 0x0d, 0x01, 0x01, 0x0b, 0x05, 0x00, 0x30, 0x13, 0x31, 0x11, 0x30,
+	0x0f, 0x06, 0x03, 0x55, 0x04, 0x03, 0x0c, 0x08, 0x74, 0x65, 0x73, 0x74,
+	0x2d, 0x6b, 0x65, 0x79, 0x30, 0x1e, 0x17, 0x0d, 0x31, 0x34, 0x31, 0x30,
+	0x30, 0x38, 0x30, 0x35, 0x34, 0x39, 0x35, 0x38, 0x5a, 0x17, 0x0d, 0x31,
+	0x34, 0x31, 0x31, 0x30, 0x37, 0x30, 0x35, 0x34, 0x39, 0x35, 0x38, 0x5a,
+	0x30, 0x13, 0x31, 0x11, 0x30, 0x0f, 0x06, 0x03, 0x55, 0x04, 0x03, 0x0c,
+	0x08, 0x74, 0x65, 0x73, 0x74, 0x2d, 0x6b, 0x65, 0x79, 0x30, 0x82, 0x01,
+	0x22, 0x30, 0x0d, 0x06, 0x09, 0x2a, 0x86, 0x48, 0x86, 0xf7, 0x0d, 0x01,
+	0x01, 0x01, 0x05, 0x00, 0x03, 0x82, 0x01, 0x0f, 0x00, 0x30, 0x82, 0x01,
+	0x0a, 0x02, 0x82, 0x01, 0x01, 0x00, 0xb2, 0x11, 0xba, 0xfc, 0xb3, 0xb5,
+	0xe9, 0xb4, 0xf4, 0x66, 0xc7, 0xe7, 0xa8, 0xed, 0xd1, 0xdb, 0xd9, 0xb2,
+	0xb4, 0x72, 0x0e, 0x7a, 0xc2, 0x00, 0xd1, 0xa3, 0x3f, 0x24, 0xa7, 0xc9,
+	0x9f, 0xef, 0x14, 0x07, 0x48, 0x2f, 0x6a, 0x54, 0xdb, 0xde, 0x72, 0xa8,
+	0xdd, 0xba, 0x2c, 0x61, 0x14, 0xd4, 0x53, 0x54, 0xe7, 0x96, 0xfd, 0xa1,
+	0x26, 0x05, 0x63, 0x1d, 0xd7, 0x1a, 0x70, 0xf8, 0xb5, 0x3d, 0x40, 0xc0,
+	0x33, 0x35, 0x8a, 0xe9, 0x88, 0x8a, 0x8a, 0x7d, 0x56, 0x39, 0x9b, 0x70,
+	0x4a, 0x07, 0xd9, 0xc2, 0x44, 0xe2, 0x12, 0x2e, 0x8b, 0x78, 0x9e, 0x14,
+	0x99, 0x7a, 0x47, 0x92, 0x9e, 0x42, 0x0f, 0x76, 0xb7, 0x3d, 0x1f, 0xb4,
+	0x20, 0xd2, 0x6d, 0x93, 0xdf, 0x2e, 0xb1, 0x00, 0xa9, 0x94, 0xe0, 0x0b,
+	0xe6, 0x57, 0x25, 0x76, 0x99, 0x63, 0xa7, 0x4c, 0x0b, 0x44, 0x48, 0x59,
+	0xbe, 0x52, 0xfb, 0x64, 0xca, 0xe0, 0x21, 0x8e, 0xaf, 0xdc, 0xa5, 0xb2,
+	0x5b, 0x4a, 0x80, 0x7e, 0xe2, 0x95, 0xa5, 0x95, 0xb7, 0x75, 0x19, 0x44,
+	0x77, 0x1b, 0x8f, 0xa0, 0x57, 0xc7, 0xb5, 0x33, 0x7f, 0xbb, 0x5b, 0x41,
+	0x63, 0xde, 0xc8, 0xdd, 0x4a, 0x41, 0x98, 0x1a, 0xc0, 0x36, 0xed, 0x8d,
+	0x4c, 0xc9, 0x2f, 0x19, 0x39, 0xf4, 0xf4, 0x31, 0xb4, 0x4e, 0x78, 0xff,
+	0xab, 0x91, 0xe6, 0xf2, 0x23, 0xdc, 0x79, 0x24, 0x54, 0xba, 0x05, 0x60,
+	0x2c, 0xad, 0x29, 0xeb, 0x8e, 0xa0, 0x2d, 0x73, 0x09, 0xbd, 0xdf, 0xe3,
+	0x76, 0x98, 0x04, 0x4d, 0x29, 0x7d, 0xdd, 0xd2, 0xbd, 0xa8, 0x32, 0x66,
+	0x45, 0x01, 0xff, 0xd7, 0xd0, 0x83, 0xfb, 0xec, 0xaa, 0xb7, 0x45, 0x34,
+	0xf4, 0xd8, 0xf1, 0x23, 0x0e, 0x15, 0x84, 0xde, 0x59, 0xe5, 0x2e, 0x06,
+	0xd6, 0xb8, 0x11, 0x1d, 0x59, 0xc9, 0x93, 0xea, 0x4e, 0x4b, 0x02, 0x03,
+	0x01, 0x00, 0x01, 0xa3, 0x50, 0x30, 0x4e, 0x30, 0x1d, 0x06, 0x03, 0x55,
+	0x1d, 0x0e, 0x04, 0x16, 0x04, 0x14, 0xe5, 0x35, 0x8b, 0x82, 0xc5, 0xf0,
+	0x10, 0x89, 0x6b, 0xe2, 0xdd, 0x60, 0x20, 0x5a, 0xd6, 0x17, 0x1e, 0x17,
+	0x2a, 0xb8, 0x30, 0x1f, 0x06, 0x03, 0x55, 0x1d, 0x23, 0x04, 0x18, 0x30,
+	0x16, 0x80, 0x14, 0xe5, 0x35, 0x8b, 0x82, 0xc5, 0xf0, 0x10, 0x89, 0x6b,
+	0xe2, 0xdd, 0x60, 0x20, 0x5a, 0xd6, 0x17, 0x1e, 0x17, 0x2a, 0xb8, 0x30,
+	0x0c, 0x06, 0x03, 0x55, 0x1d, 0x13, 0x04, 0x05, 0x30, 0x03, 0x01, 0x01,
+	0xff, 0x30, 0x0d, 0x06, 0x09, 0x2a, 0x86, 0x48, 0x86, 0xf7, 0x0d, 0x01,
+	0x01, 0x0b, 0x05, 0x00, 0x03, 0x82, 0x01, 0x01, 0x00, 0x8d, 0x9e, 0x39,
+	0xf2, 0xf8, 0x1f, 0xb3, 0x71, 0x2b, 0x2d, 0xcb, 0x22, 0xf7, 0x23, 0x88,
+	0xd4, 0x60, 0xee, 0xb1, 0xf7, 0xce, 0x39, 0x0d, 0xfd, 0xe5, 0x77, 0x5e,
+	0x69, 0xf1, 0x39, 0xc6, 0x4b, 0x16, 0x30, 0xc4, 0x95, 0x70, 0x29, 0x3b,
+	0x48, 0xe7, 0x6c, 0x33, 0x1d, 0x28, 0xa3, 0x87, 0x0e, 0xcf, 0xd3, 0x63,
+	0x1b, 0x1a, 0x51, 0x61, 0xa7, 0x4a, 0x30, 0x47, 0xbc, 0xbc, 0x10, 0xe0,
+	0x6e, 0x7b, 0x49, 0x2b, 0x77, 0xa8, 0x31, 0x0b, 0xfa, 0x64, 0xfe, 0x06,
+	0x6f, 0xab, 0x59, 0x70, 0x31, 0xcc, 0x94, 0x63, 0x3a, 0x9b, 0xea, 0x8b,
+	0xc2, 0xaa, 0x30, 0xed, 0xe0, 0x09, 0x7f, 0x16, 0x60, 0xf3, 0xc6, 0x5b,
+	0xcb, 0x7e, 0xed, 0xab, 0x54, 0x8d, 0x46, 0x1f, 0x29, 0xa3, 0xa7, 0x8c,
+	0xea, 0xb5, 0xed, 0xbe, 0x80, 0x00, 0x5f, 0x01, 0xbe, 0xa7, 0x92, 0x4f,
+	0x3b, 0xe5, 0xc8, 0x3c, 0x93, 0x41, 0xbf, 0x51, 0x1e, 0x09, 0x99, 0xbe,
+	0xb7, 0x65, 0x88, 0x93, 0x82, 0x26, 0x9b, 0x90, 0xc7, 0xb8, 0xea, 0x6b,
+	0x79, 0x0f, 0xf4, 0x5e, 0x1a, 0x8f, 0x77, 0xdd, 0xa6, 0x7a, 0x53, 0xd4,
+	0x9f, 0xb9, 0xab, 0x97, 0xdf, 0x40, 0xd8, 0x42, 0xfd, 0x1a, 0xa7, 0xa9,
+	0x90, 0x0c, 0x98, 0x7e, 0xb1, 0x5e, 0xff, 0xeb, 0xd6, 0xec, 0x65, 0xce,
+	0xd2, 0x4e, 0xd1, 0x71, 0x4b, 0xd5, 0xb8, 0x78, 0x64, 0xc2, 0x5f, 0xaf,
+	0x50, 0x20, 0xa6, 0xf0, 0xba, 0x62, 0xa3, 0xe5, 0x38, 0xa2, 0x9f, 0x17,
+	0xda, 0x65, 0xe6, 0x94, 0x1c, 0xa0, 0xc0, 0xf0, 0xf9, 0x5f, 0xeb, 0xdc,
+	0x05, 0x70, 0x73, 0x60, 0xa5, 0x54, 0x89, 0x22, 0x84, 0x93, 0x79, 0x27,
+	0xe6, 0xf6, 0x51, 0x72, 0x3e, 0x86, 0xd4, 0x7f, 0x0b, 0xb7, 0xed, 0xc4,
+	0x09, 0x0f, 0xac, 0xf5, 0x58, 0x88, 0x10, 0xee, 0x8a, 0xc2, 0xeb, 0x12,
+	0xe4, 0x31, 0x82, 0x01, 0xb6, 0x30, 0x82, 0x01, 0xb2, 0x02, 0x01, 0x01,
+	0x30, 0x20, 0x30, 0x13, 0x31, 0x11, 0x30, 0x0f, 0x06, 0x03, 0x55, 0x04,
+	0x03, 0x0c, 0x08, 0x74, 0x65, 0x73, 0x74, 0x2d, 0x6b, 0x65, 0x79, 0x02,
+	0x09, 0x00, 0xe2, 0x7d, 0x10, 0xea, 0xd8, 0x0d, 0x98, 0x77, 0x30, 0x0d,
+	0x06, 0x09, 0x60, 0x86, 0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x01, 0x05,
+	0x00, 0xa0, 0x69, 0x30, 0x18, 0x06, 0x09, 0x2a, 0x86, 0x48, 0x86, 0xf7,
+	0x0d, 0x01, 0x09, 0x03, 0x31, 0x0b, 0x06, 0x09, 0x2a, 0x86, 0x48, 0x86,
+	0xf7, 0x0d, 0x01, 0x07, 0x01, 0x30, 0x1c, 0x06, 0x09, 0x2a, 0x86, 0x48,
+	0x86, 0xf7, 0x0d, 0x01, 0x09, 0x05, 0x31, 0x0f, 0x17, 0x0d, 0x31, 0x34,
+	0x31, 0x30, 0x30, 0x38, 0x30, 0x35, 0x35, 0x32, 0x30, 0x31, 0x5a, 0x30,
+	0x2f, 0x06, 0x09, 0x2a, 0x86, 0x48, 0x86, 0xf7, 0x0d, 0x01, 0x09, 0x04,
+	0x31, 0x22, 0x04, 0x20, 0xe8, 0xd3, 0xd1, 0xba, 0xf4, 0x1b, 0x87, 0xd3,
+	0x4a, 0x66, 0x07, 0x67, 0xd5, 0x92, 0xe5, 0x9b, 0xba, 0xfc, 0xcf, 0xf0,
+	0xd8, 0xc7, 0xa6, 0xa7, 0x74, 0xce, 0x27, 0x9c, 0x9f, 0x3e, 0xaa, 0x18,
+	0x30, 0x0d, 0x06, 0x09, 0x2a, 0x86, 0x48, 0x86, 0xf7, 0x0d, 0x01, 0x01,
+	0x01, 0x05, 0x00, 0x04, 0x82, 0x01, 0x00, 0x14, 0xdb, 0xa1, 0x1a, 0x65,
+	0x21, 0xa7, 0x00, 0x3a, 0xd4, 0x4a, 0x49, 0x08, 0x90, 0x34, 0x8b, 0xbe,
+	0x6d, 0x52, 0x1d, 0x0c, 0xf6, 0x21, 0xcc, 0xdd, 0x4d, 0xb2, 0x0d, 0xc9,
+	0x0f, 0x79, 0x87, 0x19, 0x05, 0xaf, 0x1f, 0xc3, 0x8b, 0xd0, 0x52, 0xb4,
+	0x60, 0xf0, 0x28, 0x62, 0xd9, 0x70, 0xd5, 0x1b, 0xeb, 0x58, 0xea, 0x5f,
+	0x3a, 0x78, 0x3d, 0x3d, 0x55, 0x63, 0xca, 0xf3, 0xf0, 0xce, 0x38, 0x8f,
+	0x06, 0xf6, 0x21, 0x61, 0x63, 0x61, 0x37, 0xf6, 0x3d, 0x59, 0x14, 0x66,
+	0xcc, 0x2f, 0xdf, 0x52, 0x73, 0x8d, 0x32, 0xf2, 0xb9, 0x99, 0x02, 0x4f,
+	0xcb, 0xcc, 0x9e, 0x93, 0xdf, 0xf9, 0x1b, 0x71, 0x38, 0x19, 0x56, 0x15,
+	0xd5, 0xc1, 0x7c, 0x29, 0x67, 0x85, 0x69, 0x64, 0xf4, 0xeb, 0x79, 0x76,
+	0x83, 0x6d, 0x0d, 0x88, 0x87, 0x0a, 0x6e, 0xbb, 0xc4, 0xbf, 0x88, 0x2f,
+	0xa4, 0xe2, 0xd3, 0x19, 0x77, 0xbc, 0xd4, 0xa0, 0x20, 0xf9, 0xc0, 0x79,
+	0x0c, 0x39, 0x5d, 0x11, 0xcd, 0x6e, 0xc4, 0x8d, 0x75, 0xb0, 0xb9, 0x81,
+	0x66, 0xf1, 0x9e, 0xa7, 0x17, 0x6c, 0x23, 0xde, 0x5a, 0x42, 0x50, 0x85,
+	0x29, 0xbc, 0x05, 0x74, 0xe2, 0xa8, 0xbb, 0xb1, 0x86, 0xbf, 0x73, 0x4f,
+	0x72, 0xa2, 0xa8, 0xc7, 0x7e, 0x23, 0x50, 0x18, 0x33, 0x24, 0x91, 0x08,
+	0xfa, 0x43, 0x0b, 0xdc, 0xd3, 0x17, 0xd3, 0xc1, 0x43, 0x05, 0xda, 0xb2,
+	0xc4, 0xa8, 0x34, 0xcc, 0x8b, 0x52, 0xdd, 0x86, 0xba, 0xe9, 0x69, 0xe3,
+	0x87, 0x82, 0x91, 0xb9, 0x13, 0x78, 0x45, 0xc0, 0x50, 0x0c, 0xe6, 0xc9,
+	0x0b, 0x9b, 0x19, 0x93, 0x38, 0x57, 0xe4, 0x3f, 0xfc, 0x6f, 0x9f, 0x07,
+	0x96, 0x55, 0xba, 0x7c, 0x5d, 0x24, 0x12, 0xe6, 0x80, 0x54, 0x16, 0x49,
+	0xfb, 0xd9, 0xc9, 0x54, 0xb9, 0x46, 0xe5, 0x18, 0xa1, 0x69, 0xa0, 0x31,
+	0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x30, 0x61, 0x62, 0x63,
+	0x64, 0x65, 0x66
+};
+
 #endif
diff --git a/src/uefi/uefirtauthvar/uefirtauthvar.c b/src/uefi/uefirtauthvar/uefirtauthvar.c
index b30fc5b..10feb2f 100644
--- a/src/uefi/uefirtauthvar/uefirtauthvar.c
+++ b/src/uefi/uefirtauthvar/uefirtauthvar.c
@@ -258,9 +258,45 @@ static int uefirtauthvar_test2(fwts_framework *fw)
 	return FWTS_ERROR;
 }
 
+/*
+ * With one existing variable, but set authenticated variable which created by another valid key,
+ * expect EFI_SECURITY_VIOLATION returned.
+ */
+static int uefirtauthvar_test3(fwts_framework *fw)
+{
+	long ioret;
+	uint64_t status;
+	int supcheck;
+
+	ioret = setvar(&gtestguid, attributes, sizeof(AuthVarCreateDiff), AuthVarCreateDiff, &status);
+
+	if (ioret == -1) {
+		supcheck = check_fw_support(fw, status);
+		if (supcheck != FWTS_OK)
+			return supcheck;
+
+		if (status == EFI_SECURITY_VIOLATION) {
+			fwts_passed(fw, "Authenticated variable test with another valid authenticated variable passed.");
+			return FWTS_OK;
+		}
+
+		fwts_failed(fw, LOG_LEVEL_MEDIUM,
+			"UEFISetDiffAuthVar",
+			"Set different valid authenticated variable fail");
+			fwts_uefi_print_status_info(fw, status);
+	}
+
+	fwts_failed(fw, LOG_LEVEL_HIGH,
+		"UEFISetDiffAuthVar",
+		"Set authenticated variable expected fail but success");
+
+	return FWTS_ERROR;
+}
+
 static fwts_framework_minor_test uefirtauthvar_tests[] = {
 	{ uefirtauthvar_test1, "Create authenticated variable test." },
 	{ uefirtauthvar_test2, "Authenticated variable test with the same authenticated variable." },
+	{ uefirtauthvar_test3, "Authenticated variable test with another valid authenticated variable." },
 	{ NULL, NULL }
 };
 