diff --git a/src/acpi/acpitables/acpitables.c b/src/acpi/acpitables/acpitables.c
index 52b6659..1d3eb0c 100644
--- a/src/acpi/acpitables/acpitables.c
+++ b/src/acpi/acpitables/acpitables.c
@@ -859,4 +859,4 @@ static fwts_framework_ops acpi_table_check_ops = {
 	.minor_tests = acpi_table_check_tests
 };
 
-FWTS_REGISTER("acpitables", &acpi_table_check_ops, FWTS_TEST_ANYTIME, FWTS_FLAG_BATCH)
+FWTS_REGISTER("acpitables", &acpi_table_check_ops, FWTS_TEST_ANYTIME, FWTS_FLAG_BATCH | FWTS_FLAG_TEST_ACPI)
diff --git a/src/acpi/apicinstance/apicinstance.c b/src/acpi/apicinstance/apicinstance.c
index 5a4d5a2..095c2ae 100644
--- a/src/acpi/apicinstance/apicinstance.c
+++ b/src/acpi/apicinstance/apicinstance.c
@@ -82,6 +82,6 @@ static fwts_framework_ops apicinstance_ops = {
 	.minor_tests = apicinstance_tests
 };
 
-FWTS_REGISTER("apicinstance", &apicinstance_ops, FWTS_TEST_ANYTIME, FWTS_FLAG_BATCH)
+FWTS_REGISTER("apicinstance", &apicinstance_ops, FWTS_TEST_ANYTIME, FWTS_FLAG_BATCH | FWTS_FLAG_TEST_ACPI)
 
 #endif
diff --git a/src/acpi/checksum/checksum.c b/src/acpi/checksum/checksum.c
index ed98e66..a649231 100644
--- a/src/acpi/checksum/checksum.c
+++ b/src/acpi/checksum/checksum.c
@@ -155,4 +155,4 @@ static fwts_framework_ops checksum_ops = {
 	.minor_tests = checksum_tests
 };
 
-FWTS_REGISTER("checksum", &checksum_ops, FWTS_TEST_ANYTIME, FWTS_FLAG_BATCH)
+FWTS_REGISTER("checksum", &checksum_ops, FWTS_TEST_ANYTIME, FWTS_FLAG_BATCH | FWTS_FLAG_TEST_ACPI)
diff --git a/src/acpi/cstates/cstates.c b/src/acpi/cstates/cstates.c
index b58f15c..291ac21 100644
--- a/src/acpi/cstates/cstates.c
+++ b/src/acpi/cstates/cstates.c
@@ -254,6 +254,6 @@ static fwts_framework_ops cstates_ops = {
 	.minor_tests = cstates_tests
 };
 
-FWTS_REGISTER("cstates", &cstates_ops, FWTS_TEST_ANYTIME, FWTS_FLAG_BATCH)
+FWTS_REGISTER("cstates", &cstates_ops, FWTS_TEST_ANYTIME, FWTS_FLAG_BATCH | FWTS_FLAG_TEST_ACPI)
 
 #endif
diff --git a/src/acpi/dmar/dmar.c b/src/acpi/dmar/dmar.c
index 918768f..afd0327 100644
--- a/src/acpi/dmar/dmar.c
+++ b/src/acpi/dmar/dmar.c
@@ -334,6 +334,6 @@ static fwts_framework_ops dmar_ops = {
 	.minor_tests = dmar_tests
 };
 
-FWTS_REGISTER("dmar", &dmar_ops, FWTS_TEST_ANYTIME, FWTS_FLAG_BATCH)
+FWTS_REGISTER("dmar", &dmar_ops, FWTS_TEST_ANYTIME, FWTS_FLAG_BATCH | FWTS_FLAG_TEST_ACPI)
 
 #endif
diff --git a/src/acpi/fadt/fadt.c b/src/acpi/fadt/fadt.c
index 8f3abea..af0b192 100644
--- a/src/acpi/fadt/fadt.c
+++ b/src/acpi/fadt/fadt.c
@@ -194,6 +194,6 @@ static fwts_framework_ops fadt_ops = {
 	.minor_tests = fadt_tests
 };
 
-FWTS_REGISTER("fadt", &fadt_ops, FWTS_TEST_ANYTIME, FWTS_FLAG_BATCH | FWTS_FLAG_ROOT_PRIV)
+FWTS_REGISTER("fadt", &fadt_ops, FWTS_TEST_ANYTIME, FWTS_FLAG_BATCH | FWTS_FLAG_ROOT_PRIV | FWTS_FLAG_TEST_ACPI)
 
 #endif
diff --git a/src/acpi/mcfg/mcfg.c b/src/acpi/mcfg/mcfg.c
index 6748378..83f8d6f 100644
--- a/src/acpi/mcfg/mcfg.c
+++ b/src/acpi/mcfg/mcfg.c
@@ -259,6 +259,6 @@ static fwts_framework_ops mcfg_ops = {
 	.minor_tests = mcfg_tests
 };
 
-FWTS_REGISTER("mcfg", &mcfg_ops, FWTS_TEST_ANYTIME, FWTS_FLAG_BATCH | FWTS_FLAG_ROOT_PRIV)
+FWTS_REGISTER("mcfg", &mcfg_ops, FWTS_TEST_ANYTIME, FWTS_FLAG_BATCH | FWTS_FLAG_ROOT_PRIV | FWTS_FLAG_TEST_ACPI)
 
 #endif
diff --git a/src/acpi/method/method.c b/src/acpi/method/method.c
index cc1ed33..ccd6c8a 100644
--- a/src/acpi/method/method.c
+++ b/src/acpi/method/method.c
@@ -6363,4 +6363,4 @@ static fwts_framework_ops method_ops = {
 	.minor_tests = method_tests
 };
 
-FWTS_REGISTER("method", &method_ops, FWTS_TEST_ANYTIME, FWTS_FLAG_BATCH)
+FWTS_REGISTER("method", &method_ops, FWTS_TEST_ANYTIME, FWTS_FLAG_BATCH | FWTS_FLAG_TEST_ACPI)
diff --git a/src/acpi/spcr/spcr.c b/src/acpi/spcr/spcr.c
index 9fc7655..8eedb16 100644
--- a/src/acpi/spcr/spcr.c
+++ b/src/acpi/spcr/spcr.c
@@ -288,4 +288,4 @@ static fwts_framework_ops spcr_ops = {
 	.minor_tests = spcr_tests
 };
 
-FWTS_REGISTER("spcr", &spcr_ops, FWTS_TEST_ANYTIME, FWTS_FLAG_BATCH | FWTS_FLAG_ROOT_PRIV)
+FWTS_REGISTER("spcr", &spcr_ops, FWTS_TEST_ANYTIME, FWTS_FLAG_BATCH | FWTS_FLAG_ROOT_PRIV | FWTS_FLAG_TEST_ACPI)
diff --git a/src/hpet/hpet_check/hpet_check.c b/src/hpet/hpet_check/hpet_check.c
index 6679c81..7699bb2 100644
--- a/src/hpet/hpet_check/hpet_check.c
+++ b/src/hpet/hpet_check/hpet_check.c
@@ -438,6 +438,6 @@ static fwts_framework_ops hpet_check_ops = {
 };
 
 FWTS_REGISTER("hpet_check", &hpet_check_ops, FWTS_TEST_ANYTIME,
-	FWTS_FLAG_BATCH | FWTS_FLAG_ROOT_PRIV)
+	FWTS_FLAG_BATCH | FWTS_FLAG_ROOT_PRIV | FWTS_FLAG_TEST_ACPI)
 
 #endif